const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const mentions = sequelize.define(
    'mentions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  mentions.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity









































//end loop



    db.mentions.belongsTo(db.comments, {
      as: 'comment',
      foreignKey: {
        name: 'commentId',
      },
      constraints: false,
    });

    db.mentions.belongsTo(db.media_items, {
      as: 'media_item',
      foreignKey: {
        name: 'media_itemId',
      },
      constraints: false,
    });

    db.mentions.belongsTo(db.users, {
      as: 'mentioned_user',
      foreignKey: {
        name: 'mentioned_userId',
      },
      constraints: false,
    });

    db.mentions.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.mentions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.mentions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return mentions;
};


